require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"

local languageCodes = {
  ["العربية"] = "ar",
  ["الإنجليزية"] = "en",
  ["الفرنسية"] = "fr",
  ["الإسبانية"] = "es",
  ["التركية"] = "tr",
  ["الألمانية"] = "de",
  ["الهولندية"] = "nl",
  ["الإيطالية"] = "it",
  ["البرتغالية"] = "pt",
  ["الرومانية"] = "ro",
  ["الروسية"] = "ru",
  ["اليابانية"] = "ja",
  ["الصينية"] = "zh-CN",
  ["السويدية"] = "sv",
  ["التايلاندية"] = "th",
  ["الهندية"] = "hi",
  ["البولندية"] = "pl",
  ["الكورية"] = "ko",
  ["الفارسية"] = "fa",
  ["الأذربيجانية"] = "az",
  ["البنغالية"] = "bn",
  ["البلغارية"] = "bg",
  ["الكتالانية"] = "ca",
  ["التشيكية"] = "cs",
  ["الدانماركية"] = "da",
  ["اليونانية"] = "el",
  ["الإستونية"] = "et",
  ["الفلبينية"] = "fil",
  ["الفنلندية"] = "fi",
  ["الجورجية"] = "ka",
  ["الغوجاراتية"] = "gu",
  ["الكرواتية"] = "hr",
  ["الأرمنية"] = "hy",
  ["الأندونيسية"] = "id",
  ["الإسبرانتو"] = "eo",
  ["الأيسلندية"] = "is",
  ["الكنارية"] = "kn",
  ["اللاتفية"] = "lv",
  ["اللتوانية"] = "lt",
  ["المقدونية"] = "mk",
  ["المالايالامية"] = "ml",
  ["المالطية"] = "mt",
  ["الماراثية"] = "mr",
  ["النرويجية"] = "no",
  ["الأوكرانية"] = "uk",
  ["البنجابية"] = "pa",
  ["الرومانشية"] = "rm",
  ["الصربية"] = "sr",
  ["السلوفاكية"] = "sk",
  ["السلوفينية"] = "sl",
  ["السواحلية"] = "sw",
  ["التاميلية"] = "ta",
  ["التيلوغوية"] = "te",
  ["الفيتنامية"] = "vi",
  ["الويلزية"] = "cy",
  ["الأوزبكية"] = "uz",
  ["الزولو"] = "zu",
  ["العبرية"] = "iw",
  ["الأوردية"] = "ur",
  ["الطاجيكية"] = "tg"
}

local items = {
  "العربية",
  "الإنجليزية",
  "الفرنسية",
  "الإسبانية",
  "التركية",
  "الألمانية",
  "الهولندية",
  "الإيطالية",
  "البرتغالية",
  "الرومانية",
  "الروسية",
  "اليابانية",
  "الصينية",
  "السويدية",
  "التايلاندية",
  "الهندية",
  "البولندية",
  "الكورية",
  "الفارسية",
  "الأذربيجانية",
  "البنغالية",
  "البلغارية",
  "الكتالانية",
  "التشيكية",
  "الدانماركية",
  "اليونانية",
  "الإستونية",
  "الفلبينية",
  "الفنلندية",
  "الجورجية",
  "الغوجاراتية",
  "الكرواتية",
  "الأرمنية",
  "الأندونيسية",
  "الإسبرانتو",
  "الأيسلندية",
  "الكنارية",
  "اللاتفية",
  "اللتوانية",
  "المقدونية",
  "المالايالامية",
  "المالطية",
  "الماراثية",
  "النرويجية",
  "الأوكرانية",
  "البنجابية",
  "الرومانشية",
  "الصربية",
  "السلوفاكية",
  "السلوفينية",
  "السواحلية",
  "التاميلية",
  "التيلوغوية",
  "الفيتنامية",
  "الويلزية",
  "الأوزبكية",
  "الزولو"
}

local layout = {
  GridView,
  id = "grid",
  numColumns = 1,
  layout_width = "fill",
  layout_height = "fill"
}

local dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))

dlg.setTitle("الترجمة الفورية")
  .setMessage("اختر اللغة التي تريد الترجمة إليها.")
  .setButton("خروج", nil)
  .show()

grid.onItemClick = function(l, v)
  dlg.dismiss()
  task(500, function()
    local language = v.text
    local defaultLanguage = Locale.getDefault().getLanguage()
    local languageCode = languageCodes[language]

    if languageCode then
      local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(this.getText(node))
      url = url .. "&tl=" .. languageCode

      Http.get(url, function(status, result)
        if status == 200 then
          print(result:match('<div class="result%-container">([^<]+)</div>'))
        else
          print("عذرا، حدث خطأ ما.\n قد تساعد هذه الطرق على حل المشكلة: \n - تأكد من اتصالك بالإنترنت. \n - حاول توفير إنترنت جيد. \n ملاحظة: لا يمكن ترجمة بعض العناصر، الصور ومربعات التعديل وغيرها.")
        end
      end)
    else
      print("لغة غير مدعومة")
    end
  end)
end